## gate.creole
Class ParameterList

    java.lang.Object
      |
      +--gate.creole.ParameterList

All Implemented Interfaces:
  Serializable

public class ParameterList
extends Object
implements Serializable

Models resource parameters lists as described in their `creole.xml` metadata. Parameters are stored as lists of disjunctions (`OR'd` sets in the metadata).

See Also:
  Serialized Form

Constructor Summary
`ParameterList()`

Method Summary
`boolean` `add(List disjunction)` Add a parameter disjunction.
`boolean` `addAll(List c)` Add all the members of a parameter list (as individual disjunctions)
`FeatureMap` `getDefaults(List parameters)` Get default parameter value set.
`FeatureMap` `getInitimeDefaults()` Get default initime parameter value set.
`List` `getInitimeParameters()` Get the list of initialisation-time parameters (as a list of parameter disjunctions).
`FeatureMap` `getRuntimeDefaults()` Get default runtime parameter value set.
`List` `getRuntimeParameters()` Get the list of runtime parameters (as a list of parameter disjunctions).
`boolean` `isFullyDefaulted()` Get the status of the last run of `getDefaults(List)`.
`String` `toString()` String representation

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ParameterList

    public ParameterList()

Method Detail

### getRuntimeParameters

    public List getRuntimeParameters()

  Get the list of runtime parameters (as a list of parameter disjunctions).

### getInitimeParameters

    public List getInitimeParameters()

  Get the list of initialisation-time parameters (as a list of parameter disjunctions).

### add

    public boolean add(List disjunction)

  Add a parameter disjunction. It is assumed that the parameters in a disjunction are all runtime or all init-time, never a mix of the two.
  Throws:
    `NoSuchElementException` - disjunction has no more elements.

### addAll

    public boolean addAll(List c)

  Add all the members of a parameter list (as individual disjunctions)

### getRuntimeDefaults

    public FeatureMap getRuntimeDefaults()
                                  throws ParameterException

  Get default runtime parameter value set. Calls `getDefaults(List)`.
  See Also:
    `getDefaults(List)`

### getInitimeDefaults

    public FeatureMap getInitimeDefaults()
                                  throws ParameterException

  Get default initime parameter value set. Calls `getDefaults(List)`.
  See Also:
    `getDefaults(List)`

### getDefaults

    public FeatureMap getDefaults(List parameters)
                           throws ParameterException

  Get default parameter value set. Where more than one default is possible amongst disjunctive parameters, only the first will be set. To check if the default set is comprehensive, use `isFullyDefaulted()`.
  See Also:
    `isFullyDefaulted()`

### isFullyDefaulted

    public boolean isFullyDefaulted()

  Get the status of the last run of `getDefaults(List)`. If the last run managed to find a default for all parameters that are part of a disjunction of which none are optional, then this status is true; else it is false.
  See Also:
    `getDefaults(List)`

### toString

    public String toString()

  String representation
  Overrides:
    `toString` in class `Object`